<?php

# PHP cli helper which sets options to the desired value, either via YAML on
# stdin or key and value arguments on the command line.
#
# Example use:
# php ./_update_option.php akismet_strictness 1


@include "wp-config.php";
@include_once "wp-includes/option.php";
@include_once "wp-includes/functions.php";
@include "Symfony/Component/Yaml/Yaml.php";
@include "Symfony/Component/Yaml/Dumper.php";
@include "Symfony/Component/Yaml/Inline.php";
@include "Symfony/Component/Yaml/Escaper.php";

use Symfony\Component\Yaml\Yaml;

function check_and_set_option( $name, $value ) {
    $value = maybe_unserialize($value);
    $option = get_option($name);
    if ($option == false) {
        add_option($name, $value);
        update_option($name, $value);
        print "+$name:\t$value\n";
    } else if ($option != $value) {
        update_option($name, $value);
        print "-$name:\t$option\n+$name:\t$value\n";
    } else {
        print " $name:\t$option\n";
    }
    $option = get_option($name);
    print_r($option);
    print(serialize($option));
}

if (count($argv) == 3) {
    check_and_set_option($argv[1], $argv[2]);
} else {
    $options = Yaml::parse(file_get_contents('php://stdin'));
    foreach ($options as $key => $val) {
        check_and_set_option($key, $val);
    }
}
